unit Unit2;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Orsa, hyieutils, iexBitmaps, hyiedefs,
  iesettings, ieview, imageenview, ievect, Vcl.ExtCtrls, Vcl.StdCtrls,
  ieopensavedlg;

type
  TForm2 = class(TForm)
    Panel1: TPanel;
    PaintSource: TImageEnVect;
    openDialog: TOpenImageEnDialog;
    Button1: TButton;
    Button2: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  fOrsaEntry : ORSA_entry;
  SiftParams: SiftPar;
  DataOrsa: orsaData;

implementation

{$R *.dfm}

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  fOrsaEntry := GetProcAddress(DLLHandle, 'ORSA_Clean');
  fOrsaEntry(SiftParams, DataOrsa);
end;

procedure TForm2.FormShow(Sender: TObject);
begin
{Initialize SIFT and ORSA structures}
fOrsaEntry := GetProcAddress(DLLHandle, 'ORSA_Init');
fOrsaEntry(SiftParams, DataOrsa);
SiftParams.InitSigma	 := 1.6;
SiftParams.DoubleImSize := 0;
DataOrsa.OutputPanorama := False;
DataOrsa.OutputReg1 := False;
DataOrsa.OutputReg2 := False;
end;
procedure getScline(var image: imageData; map: TIEBitmap);
var
  i: Integer;
begin
  image.Width  := map.Width;
  image.Height := map.Height;
  SetLength(image.Scline, image.Height);
  for i := 0 to map.Height do
      image.Scline[i] := PByte(map.ScanLine[i]);
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
if (openDialog.Execute()) then
   begin
   PaintSource.RemoveAllObjects();
   PaintSource.IO.LoadFromFile(openDialog.FileName);
   getScline(DataOrsa.Source.Image, PaintSource.IEBitmap);
   end;
end;

procedure TForm2.Button2Click(Sender: TObject);
type Pkeypoint = ^keypoint;
var kpSource : TList;
    hobj, radius, i : Integer;
    key: keypoint;
begin
   PaintSource.RemoveAllObjects();
   fOrsaEntry := GetProcAddress(DLLHandle, 'ORSA_SIFT_Descriptor_Source');
   fOrsaEntry(SiftParams, DataOrsa);
   for i := 0 to DataOrsa.Source.KeyPoints.Count - 1 do
	   begin
	   key  := DataOrsa.Source.KeyPoints.Data[i];
	   hobj := PaintSource.AddNewObject();
	   radius := round(key.scale * SiftParams.InitSigma);
	   PaintSource.ObjPenColor[hobj] := clAqua;
	   PaintSource.ObjKind[hobj] := iekELLIPSE;
	   PaintSource.ObjTop[hobj]  :=  round(key.y) - radius;
	   PaintSource.ObjLeft[hobj] :=  round(key.x) - radius;
	   PaintSource.ObjWidth[hobj] :=  radius*2;
	   PaintSource.ObjHeight[hobj] := radius*2;
	   end;

PaintSource.Update();
end;

function BitmapFromScline(var image: imageData): TIEBitmap;
{I don't know...maybe this works. More experienced Delphi programer should correct it}
var
  map :TIEBitmap;
  i,j: Integer;
  outByte: PByte;
  inByte:  PByte;

begin
    map := TIEBitmap.Create(image.Width, image.Height, ie24RGB);
    for i := 0 to image.Height - 1 do
        outByte := image.Scline[i];
        inByte  := image.Scline[i];
        begin
        for j := 0 to image.Width*3 do
            begin
              outByte := inByte;
              outByte^ := outByte^ + 1;
            end;
        end;
Result := map;
end;

end.

